
var actionVal, actionID, id, filename;

const TRANSLATION_DATA = JSON.parse($('#store-data-translation').val());

//confirm delete
$(".btn-cnf-delete").click(function () {
    const username = $(this).attr('data-username');
    id = $(this).attr('data-id');
    filename = $(this).attr('data-filename')
    $('.show-username').text(username)
})

//delete
$(".btn-delete").click(function () {
    location.href = baseUrl + TRANSLATION_DATA.rys_path_dir +'/delete.php?id=' + id;
})

//dropdown
$('.custom-select').change(function () {
    const $option = $(this).find(`option:selected`);
    const value = $option.val();//to get content of "value" attrib
    actionVal = $option.val()
    if(actionVal) {
        $('.btn-submit-reject').css({
            'pointer-events': 'auto',
            'cursor': 'pointer',
            'opacity': '1'
        })
    }
    if(value == 'reject') {
        $('#txt-msg').removeClass('d-none')
        $('#txt-msg').addClass('d-block')
    } else {
        $('#txt-msg').addClass('d-none')
        $('#txt-msg').removeClass('d-block')
        //hide validation message required
        $('#msgHelp').addClass('d-none')
        $('#msgHelp').removeClass('d-block')
    }    
})

function hideFieldsByQueries(queries) {
    $('#exampleModalCenterInfo .form-group').removeClass('d-none');
    let queryies_str = queries.join(', ');
    $(queryies_str).closest('.form-group').addClass('d-none');
}

function labelPlaceHolderChanger(array) {
    array.forEach((object) => {
        let query = object.query;
        let text = object.text;

        let element = $(query);
        let formGroup = $( element.closest('.form-group') );
        let label = $( formGroup.find('label') );

        label.text(text);
    });
}

/**
 * the function to add 'click' event to the preview info buttons
 */
function addEventBtnsViewInfo() {
    //view info
    $(".btn-view-info").click(function (e) {     
        const mgsTxt = $(this).attr('data-msg')
        const tr = $(this).closest("tr")
        //const colIndex = $(this).closest('td').index();
        const rowIndex = tr.index()
        const id = $('#table tbody tr:eq('+ rowIndex +') td:eq(0)').attr('data-id')
        actionID = $('#table tbody tr:eq('+ rowIndex +') td:eq(0)').attr('data-id')
        const username = $('#table tbody tr:eq('+ rowIndex +') td:eq(1)').attr('data-username')
        const email = $('#table tbody tr:eq('+ rowIndex +') td:eq(2)').attr('data-email')
        const mobile = $('#table tbody tr:eq('+ rowIndex +') td:eq(3)').attr('data-mobile')

        // ================ hidden ================
        const schoolName = $('#table tbody tr:eq('+ rowIndex +') td:eq(4)').attr('data-schoolName')
        const schoolAddress = $('#table tbody tr:eq('+ rowIndex +') td:eq(5)').attr('data-schoolAddress')
        const schoolEmailAddress = $('#table tbody tr:eq('+ rowIndex +') td:eq(6)').attr('data-schoolEmailAddress')
        const schoolPhoneNo = $('#table tbody tr:eq('+ rowIndex +') td:eq(7)').attr('data-schoolPhoneNo')
        const principalName = $('#table tbody tr:eq('+ rowIndex +') td:eq(8)').attr('data-principalName')
        const selectOption = $('#table tbody tr:eq('+ rowIndex +') td:eq(9)').attr('data-selectOption')
        const principalContactNo = $('#table tbody tr:eq('+ rowIndex +') td:eq(10)').attr('data-principalContactNo')
        const principalEmail = $('#table tbody tr:eq('+ rowIndex +') td:eq(11)').attr('data-principalEmail')
        const status = $('#table tbody tr:eq('+ rowIndex +') td:eq(13)').attr('data-status')
        actionVal = $('#table tbody tr:eq('+ rowIndex +') td:eq(13)').attr('data-status')
        const createdAt = $('#table tbody tr:eq('+ rowIndex +') td:eq(14)').attr('data-createdAt');
        const updatedAt = $('#table tbody tr:eq('+ rowIndex +') td:eq(15)').attr('data-updatedAt');

        //active select option
        $('#dropdown_selector option[value="'+ status +'"]').prop("selected", true)
        if(status !== 'reject') {
            $('#txt-msg').addClass('d-none')
            $('#txt-msg').removeClass('d-block')
            //hide validation message required
            $('#msgHelp').addClass('d-none')
            $('#msgHelp').removeClass('d-block')
        }else {
            //reject
            $('#txt-msg').removeClass('d-none')
            $('#txt-msg').addClass('d-block')
        }

        $('#admin_user_name').val(username)
        $('#admin_email_address').val(email)
        $('#admin_mobile_number').val(mobile)
        $('#admin_school_name').val(schoolName)
        $('#admin_school_address').val(schoolAddress)
        $('#admin_school_email_address').val(schoolEmailAddress)
        $('#admin_school_phone_no').val(schoolPhoneNo)
        $('#admin_principal_name').val(principalName)
        $(`input[value="${selectOption}"]`).prop('checked', true);
        $('#admin_principal_contact_no').val(principalContactNo)
        $('#admin_principal_email').val(principalEmail);
        $('#admin_status').val(status)
        $('#admin_created').val(createdAt);
        $('#admin_updated').val(updatedAt);
        $('#txt-msg').val(mgsTxt)
        


        let defaultLabels = [
            {
                query: '#admin_school_name',
                text: TRANSLATION_DATA.label_school_name,
            },
            {
                query: '#admin_principal_name',
                text: TRANSLATION_DATA.label_principal_Name,
            },
            {
                query: '#admin_principal_contact_no',
                text: TRANSLATION_DATA.label_principal_contact_number,
            },
            {
                query: '#admin_school_address',
                text: TRANSLATION_DATA.label_school_address,
            },
            {
                query: '#admin_school_email_address',
                text: TRANSLATION_DATA.label_school_email_address,
            },
            {
                query: '#admin_school_phone_no',
                text: TRANSLATION_DATA.label_school_contact_number,
            },
        ];

        let queriesToHide = [];
        let labelsToChange = [];

        if (selectOption === 'community') {
            queriesToHide = [
                '#admin_school_address',
                '#admin_school_email_address',
                '#admin_school_phone_no',
            ]
            labelsToChange = [
                {
                    query: '#admin_school_name',
                    text: TRANSLATION_DATA.label_community_name,
                },
                {
                    query: '#admin_principal_name',
                    text: TRANSLATION_DATA.label_community_leader_name,
                },
                {
                    query: '#admin_principal_contact_no',
                    text: TRANSLATION_DATA.label_community_leader_contact_number,
                },
            ];
        } else if (selectOption === 'teacher') {
            queriesToHide = [
                '#admin_principal_name',
                '#admin_principal_contact_no',
                '#admin_principal_email',
            ]
            labelsToChange = defaultLabels;
        } else if (selectOption === 'principal') {
            queriesToHide = [
                '#admin_principal_email',
            ];
            labelsToChange = defaultLabels;
        } else {
            queriesToHide = [
                '#admin_principal_name',
                '#admin_principal_contact_no',
                '#admin_principal_email',
            ]
            labelsToChange = [
                {
                    query: '#admin_school_name',
                    text: TRANSLATION_DATA.label_organization_name,
                },
                {
                    query: '#admin_school_address',
                    text: TRANSLATION_DATA.label_organization_address,
                },
                {
                    query: '#admin_school_email_address',
                    text: TRANSLATION_DATA.label_organization_email_address,
                },
                {
                    query: '#admin_school_phone_no',
                    text: TRANSLATION_DATA.label_organization_contact_number,
                },
            ];
        }


        labelPlaceHolderChanger(labelsToChange);
        hideFieldsByQueries(queriesToHide);
    })
}

//reject 
$('.btn-submit-reject').click(function () {
    const valueReject = $('.txt-msg').val()
    if(actionVal === 'reject') {
        if(valueReject == '') {
            $('.msgHelp').removeClass('d-none')
            $('.msgHelp').addClass('d-block')
            $('.txt-msg').focus()
            return
        }
    }
    location.href = baseUrl + TRANSLATION_DATA.rys_path_dir + '/status.php?id=' + actionID + '&status=' + actionVal+ '&msg=' + valueReject
})

/* datatable initialized event */
$(document).on( 'init.dt', function ( e, settings ) {

    /* disable ordering */
    $.extend( $.fn.dataTable.defaults, {
        ordering: false,
    } );

} );

/* datatable draw data event */
$('#table').on( 'draw.dt', function () {
    
    /* add event to all preview info buttons */
    if (typeof addEventBtnsViewInfo === 'function') {
        addEventBtnsViewInfo();
    }
    
} );